## libmirisdr 0.0.4.59ba37

=== CMakeLists.txt ===
# Copyright 2012 OSMOCOM Project
#
# This file is part of MiriSDR
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 2.6)
project(mirisdr C)

#select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

# Set the version information here
set(VERSION_INFO_MAJOR_VERSION 0) # increment major on api compatibility changes
set(VERSION_INFO_MINOR_VERSION 0) # increment minor on feature-level changes
set(VERSION_INFO_PATCH_VERSION git) # increment patch for bug fixes and docs
include(Version) # setup version info

########################################################################
# Compiler specific setup
########################################################################
if(CMAKE_COMPILER_IS_GNUCC AND NOT WIN32)
    ADD_DEFINITIONS(-Wall)
    ADD_DEFINITIONS(-Wextra)
    ADD_DEFINITIONS(-Wno-unused)
    ADD_DEFINITIONS(-Wsign-compare)
    #http://gcc.gnu.org/wiki/Visibility
    add_definitions(-fvisibility=hidden)
endif()

########################################################################
# Find build dependencies
########################################################################
find_package(PkgConfig)
find_package(LibUSB)

if(NOT LIBUSB_FOUND)
    message(FATAL_ERROR "LibUSB 1.0 required to compile MiriSDR")
endif()

########################################################################
# Setup the include and linker paths
########################################################################
include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${LIBUSB_INCLUDE_DIR}
)

#link_directories(
#    ...
#)

# Set component parameters
#set(INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include CACHE INTERNAL "" FORCE)

########################################################################
# Create uninstall target
########################################################################
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include)
add_subdirectory(src)

########################################################################
# Create Pkg Config File
########################################################################
FOREACH(inc ${LIBUSB_INCLUDE_DIR})
    LIST(APPEND MIRISDR_PC_CFLAGS "-I${inc}")
ENDFOREACH(inc)

FOREACH(lib ${LIBUSB_LIBRARY_DIRS})
    LIST(APPEND MIRISDR_PC_LIBS "-L${lib}")
ENDFOREACH(lib)

# use space-separation format for the pc file
STRING(REPLACE ";" " " MIRISDR_PC_CFLAGS "${MIRISDR_PC_CFLAGS}")
STRING(REPLACE ";" " " MIRISDR_PC_LIBS "${MIRISDR_PC_LIBS}")

# unset these vars to avoid hard-coded paths to cross environment
IF(CMAKE_CROSSCOMPILING)
    UNSET(MIRISDR_PC_CFLAGS)
    UNSET(MIRISDR_PC_LIBS)
ENDIF(CMAKE_CROSSCOMPILING)

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix \${prefix})
set(libdir \${exec_prefix}/lib)
set(includedir \${prefix}/include)

CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/libmirisdr.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/libmirisdr.pc
@ONLY)

INSTALL(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/libmirisdr.pc
    DESTINATION lib/pkgconfig
)

########################################################################
# Print Summary
########################################################################
MESSAGE(STATUS "Building for version: ${VERSION} / ${LIBVER}")
MESSAGE(STATUS "Using install prefix: ${CMAKE_INSTALL_PREFIX}")

=== include/CMakeLists.txt ===
# Copyright 2012 OSMOCOM Project
#
# This file is part of MiriSDR
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Install public header files
########################################################################
install(FILES
    mirisdr.h
    mirisdr_export.h
    DESTINATION include
)

=== src/CMakeLists.txt ===
# Copyright 2012 OSMOCOM Project
#
# This file is part of MiriSDR
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Setup library
########################################################################
add_library(mirisdr_shared SHARED
    libmirisdr.c
    tuner_msi001.c
)

target_link_libraries(mirisdr_shared
    ${LIBUSB_LIBRARIES}
)

set_target_properties(mirisdr_shared PROPERTIES DEFINE_SYMBOL "mirisdr_EXPORTS")
set_target_properties(mirisdr_shared PROPERTIES OUTPUT_NAME mirisdr)
set_target_properties(mirisdr_shared PROPERTIES SOVERSION ${MAJOR_VERSION})
set_target_properties(mirisdr_shared PROPERTIES VERSION ${LIBVER})

add_library(mirisdr_static STATIC
    libmirisdr.c
    tuner_msi001.c
)

target_link_libraries(mirisdr_static
    ${LIBUSB_LIBRARIES}
)

set_property(TARGET mirisdr_static APPEND PROPERTY COMPILE_DEFINITIONS "mirisdr_STATIC" )

if(NOT WIN32)
# Force same library filename for static and shared variants of the library
set_target_properties(mirisdr_static PROPERTIES OUTPUT_NAME mirisdr)
endif()

########################################################################
# Build utility
########################################################################
add_executable(miri_sdr miri_sdr.c)
target_link_libraries(miri_sdr mirisdr_static
    ${LIBUSB_LIBRARIES}
)

if(WIN32)
set_property(TARGET miri_sdr APPEND PROPERTY COMPILE_DEFINITIONS "mirisdr_STATIC" )
endif()

########################################################################
# Install built library files & utilities
########################################################################
install(TARGETS mirisdr_shared mirisdr_static miri_sdr
    LIBRARY DESTINATION lib${LIB_SUFFIX} # .so/.dylib file
    ARCHIVE DESTINATION lib${LIB_SUFFIX} # .lib file
    RUNTIME DESTINATION bin              # .dll file
)

=== debian/changelog ===
libmirisdr (0.0.4.59ba37-5) unstable; urgency=medium

  * swap short descriptions. Thanks Daniele! (Closes: #813996)
  * lintian fixes

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 26 Apr 2016 21:02:31 -0400

libmirisdr (0.0.4.59ba37-4) unstable; urgency=medium

  * update standards-version

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 28 Nov 2015 21:58:30 -0500

libmirisdr (0.0.4.59ba37-3) unstable; urgency=medium

  * Lintian cleanup of packaging

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 27 Nov 2015 20:23:37 -0500

libmirisdr (0.0.4.59ba37-2) unstable; urgency=low

  * Find libusb on kFreeBSD

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 18 Apr 2014 17:01:55 -0400

libmirisdr (0.0.4.59ba37-1) unstable; urgency=low

  * New package (Closes: #724966)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 13 Apr 2014 14:57:08 -0400

=== debian/control ===
Source: libmirisdr
Section: libs
Priority: extra
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper (>= 9.0.0~),
               libusb-1.0-0-dev [linux-any],
               libusb-dev [hurd-i386],
               libusb2-dev [kfreebsd-any],
               pkg-config
Standards-Version: 3.9.6
Homepage: http://sdr.osmocom.org/trac/

Package: libmirisdr-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libmirisdr0 (= ${binary:Version}), ${misc:Depends}
Description: Software defined radio support for Mirics hardware (development files)
 Software for the Mirics MSi2500 + MSi001 SDR platform
 .
 The hardware part of MiriSDR brings information from an antenna connector
 to a USB plug.
 .
 This package is the software that provides control of the USB hardware
 and an API to pass data to software defined radio applications on the host.
 .
 This package contains development files.

Package: libmirisdr0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Software defined radio support for Mirics hardware (library)
 Software for the Mirics MSi2500 + MSi001 SDR platform
 .
 The hardware part of MiriSDR brings information from an antenna connector
 to a USB plug.
 .
 This package is the software that provides control of the USB hardware
 and an API to pass data to software defined radio applications on the host.
 .
 This package contains the shared library.

Package: miri-sdr
Architecture: any
Depends: libmirisdr0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Software defined radio support for Mirics hardware (tools)
 Software for the Mirics MSi2500 + MSi001 SDR platform
 .
 The hardware part of MiriSDR brings information from an antenna connector
 to a USB plug.
 .
 This package is the software that provides control of the USB hardware
 and an API to pass data to software defined radio applications on the host.
 .
 This package contains a set of command line utilities:

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH

%:
	dh $@

override_dh_auto_configure: debian/libmirisdr0.udev
	dh_auto_configure -- -DLIB_INSTALL_DIR=lib/$(DEB_HOST_MULTIARCH)

debian/libmirisdr0.udev: mirisdr.rules
	cp -p mirisdr.rules debian/libmirisdr0.udev

## libmirisdr 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,19 @@
 cmake_minimum_required(VERSION 2.6)
 project(mirisdr C)
 
+# use, i.e. don't skip the full RPATH for the build tree
+set(CMAKE_SKIP_BUILD_RPATH  FALSE)
+
+# when building, don't use the install RPATH already
+# (but later on when installing)
+set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
+
+SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+
+# add the automatically determined parts of the RPATH
+# which point to directories outside the build tree to the install RPATH
+set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+
 #select the release build type by default to get optimization flags
 if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
@@ -33,7 +46,7 @@
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)
 
 # Set the version information here
-set(VERSION_INFO_MAJOR_VERSION 0) # increment major on api compatibility changes
+set(VERSION_INFO_MAJOR_VERSION 4) # increment major on api compatibility changes
 set(VERSION_INFO_MINOR_VERSION 0) # increment minor on feature-level changes
 set(VERSION_INFO_PATCH_VERSION git) # increment patch for bug fixes and docs
 include(Version) # setup version info
@@ -55,6 +68,8 @@
 ########################################################################
 find_package(PkgConfig)
 find_package(LibUSB)
+set(THREADS_USE_PTHREADS_WIN32 true)
+find_package(Threads)
 
 if(NOT LIBUSB_FOUND)
     message(FATAL_ERROR "LibUSB 1.0 required to compile MiriSDR")
@@ -87,6 +102,18 @@
     ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
 )
 
+
+########################################################################
+# Handle detach kernel driver option
+########################################################################
+option(DETACH_KERNEL_DRIVER "Detach kernel driver if loaded" OFF)
+if (DETACH_KERNEL_DRIVER)
+    message (STATUS "Building with kernel driver detaching enabled")
+    add_definitions(-DDETACH_KERNEL_DRIVER=1)
+else (DETACH_KERNEL_DRIVER)
+    message (STATUS "Building with kernel driver detaching disabled, use -DDETACH_KERNEL_DRIVER=ON to enable")
+endif (DETACH_KERNEL_DRIVER)
+
 ########################################################################
 # Add subdirectories
 ########################################################################
@@ -116,7 +143,7 @@
 
 set(prefix ${CMAKE_INSTALL_PREFIX})
 set(exec_prefix \${prefix})
-set(libdir \${exec_prefix}/lib)
+set(libdir \${exec_prefix}/lib${LIB_SUFFIX})
 set(includedir \${prefix}/include)
 
 CONFIGURE_FILE(
@@ -126,7 +153,7 @@
 
 INSTALL(
     FILES ${CMAKE_CURRENT_BINARY_DIR}/libmirisdr.pc
-    DESTINATION lib/pkgconfig
+    DESTINATION lib${LIB_SUFFIX}/pkgconfig
 )
 
 ########################################################################

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,6 @@
 ########################################################################
 add_library(mirisdr_shared SHARED
     libmirisdr.c
-    tuner_msi001.c
 )
 
 target_link_libraries(mirisdr_shared
@@ -36,8 +35,13 @@
 
 add_library(mirisdr_static STATIC
     libmirisdr.c
-    tuner_msi001.c
 )
+
+if(WIN32)
+add_library(libgetopt_static STATIC
+    getopt/getopt.c
+)
+endif()
 
 target_link_libraries(mirisdr_static
     ${LIBUSB_LIBRARIES}
@@ -54,18 +58,34 @@
 # Build utility
 ########################################################################
 add_executable(miri_sdr miri_sdr.c)
-target_link_libraries(miri_sdr mirisdr_static
+add_executable(miri_fm miri_fm.c)
+set(INSTALL_TARGETS mirisdr_shared mirisdr_static miri_sdr miri_fm)
+
+target_link_libraries(miri_sdr mirisdr_shared
     ${LIBUSB_LIBRARIES}
+    ${CMAKE_THREAD_LIBS_INIT}
 )
 
+target_link_libraries(miri_fm mirisdr_shared
+    ${LIBUSB_LIBRARIES}
+    ${CMAKE_THREAD_LIBS_INIT}
+)
+
+if(UNIX)
+target_link_libraries(miri_fm m)
+endif()
+
 if(WIN32)
+target_link_libraries(miri_sdr libgetopt_static)
+target_link_libraries(miri_fm libgetopt_static)
 set_property(TARGET miri_sdr APPEND PROPERTY COMPILE_DEFINITIONS "mirisdr_STATIC" )
+set_property(TARGET miri_fm APPEND PROPERTY COMPILE_DEFINITIONS "mirisdr_STATIC" )
 endif()
 
 ########################################################################
 # Install built library files & utilities
 ########################################################################
-install(TARGETS mirisdr_shared mirisdr_static miri_sdr
+install(TARGETS ${INSTALL_TARGETS}
     LIBRARY DESTINATION lib${LIB_SUFFIX} # .so/.dylib file
     ARCHIVE DESTINATION lib${LIB_SUFFIX} # .lib file
     RUNTIME DESTINATION bin              # .dll file

=== debian/changelog ===
libmirisdr (2.0.0-4) unstable; urgency=medium

  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 20 Dec 2023 22:28:15 -0500

libmirisdr (2.0.0-3) experimental; urgency=medium

  * upload to experimental for dumat tool
  * Move udev files from /lib to /usr/lib, including protective diversion
    against Multi-Arch: same file loss scenario (DEP17 P7 M10).
    (Closes: #1058787)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 16 Dec 2023 08:56:56 -0500

libmirisdr (2.0.0-2) unstable; urgency=medium

  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 15 Dec 2023 17:56:10 -0500

libmirisdr (2.0.0-1) experimental; urgency=medium

  * New upstream release (Closes: #964875)
    Improvements
    - Better support of SDRPlay through a "flavour" option in the open
      function. This indicator can be used throughout the code if
      necessary. At present it drives the frequency plan that drives the
      choice between the different receiving paths of the MSi001 depending
      on frequency.
    - Remove useless auto gain feature that is just fixed
      gain in fact. The setter/getter still exists for compatibility but
      effectively does nothing.
    - Use more meaningful variable names for what is
      actually gain reductions and not gains.
    - Some comments in the code were translated from
      Czech to English (Google translated) to ease understanding by the
      masses.
   Bug fixes
    - Stop using a deprecated version of libusb.h (1.0.13) and rely on the
      one installed in the system or specified in the cmake command line.
    - Restore gain settings after a frequency, bandwidth or IF change as
      this affects the gain settings.
    - Corrected baseband gain setting.
  * update watch file
  * update man pages
  * add AppStream metadata describing hardware support
  * upload to experimental for soversion bump

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 14 Dec 2023 20:09:53 -0500

libmirisdr (1.1.2-1) UNRELEASED; urgency=low

  * New upstream release (2017-12-20)
    Upstream moved, last maintainer is f4exb
    many new SDR hardware supported
    + soname bumped

 -- nicoo <nicoo@debian.org>  Sat, 11 Jul 2020 16:02:56 +0200

libmirisdr (0.0.4.59ba37-8) unstable; urgency=medium

  * change section of miri-sdr to comm

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 05 Dec 2023 22:04:40 -0500

libmirisdr (0.0.4.59ba37-7) unstable; urgency=medium

  * upload to unstable (Closes: #1056929)

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 05 Dec 2023 21:41:49 -0500

libmirisdr (0.0.4.59ba37-6) experimental; urgency=medium

  [ Chris Hofstaedtler ]
  * Move udev files from /lib to /usr/lib, including protective diversion
    against Multi-Arch: same file loss scenario (DEP17 P7 M10). (Closes: #-1)
  * Remove obsolete postinst tasks (ldconfig, udev reload), now handled by
    triggers.

  [ A. Maitland Bottoms ]
  * update Standards-Version, extra->optional, use debhelper-compat, https
  * prepare for team maintenance updates
  * upload to experimental as requested in #1057190

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 03 Dec 2023 13:40:25 -0500

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,19 @@
 Source: libmirisdr
 Section: libs
-Priority: extra
+Priority: optional
 Maintainer: A. Maitland Bottoms <bottoms@debian.org>
-Build-Depends: cmake,
-               debhelper (>= 9.0.0~),
-               libusb-1.0-0-dev [linux-any],
-               libusb-dev [hurd-i386],
-               libusb2-dev [kfreebsd-any],
-               pkg-config
-Standards-Version: 3.9.6
-Homepage: http://sdr.osmocom.org/trac/
+Build-Depends: cmake, debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config
+Standards-Version: 4.6.2
+Homepage: https://github.com/f4exb/libmirisdr-4/
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/libmirisdr/
+Vcs-Git: https://salsa.debian.org/debian-hamradio-team/libmirisdr.git
 
 Package: libmirisdr-dev
 Section: libdevel
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libmirisdr0 (= ${binary:Version}), ${misc:Depends}
+Depends: libmirisdr4 (= ${binary:Version}), ${misc:Depends}
 Description: Software defined radio support for Mirics hardware (development files)
  Software for the Mirics MSi2500 + MSi001 SDR platform
  .
@@ -27,7 +25,7 @@
  .
  This package contains development files.
 
-Package: libmirisdr0
+Package: libmirisdr4
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -44,8 +42,9 @@
  This package contains the shared library.
 
 Package: miri-sdr
+Section: comm
 Architecture: any
-Depends: libmirisdr0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libmirisdr4 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Software defined radio support for Mirics hardware (tools)
  Software for the Mirics MSi2500 + MSi001 SDR platform
  .

=== debian/rules ===
#!/usr/bin/make -f
DEB_BUILD_MAINT_OPTIONS += hardening=+all
export DEB_BUILD_MAINT_OPTIONS

%:
	dh $@ --buildsystem=cmake

override_dh_installudev:
	dh_installudev
	set -e; if test -d debian/libmirisdr4/lib/udev/rules.d; then mv debian/libmirisdr4/lib/udev debian/libmirisdr4/usr/lib; fi
	set -e; if test -d debian/libmirisdr4/lib; then rmdir debian/libmirisdr4/lib; fi

=== debian/watch ===
version=4
 opts="\
 dversionmangle=s%\+dfsg\d*%%, \
 uversionmangle=s/-rc/~rc/, \
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%libmirisdr-$1%" \
 https://github.com/f4exb/libmirisdr-4/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
